/* Object header and related functions
 * Author: Mike Buerli F2010 */

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <vector>
#include <iostream>
#include <fstream>
#include <assert.h>
#include <map>
#include <cstring>
#include "tex.h"

#if 1 /*unix*/
#include <GL/glut.h>
#endif

#if 0 /*apple */
#include <GLUT/glut.h>
#include <OPENGL/gl.h>
#include <OPENGL/glext.h>
#endif

#if 0 /*windows*/
 #include <io.h>
#include <fcntl.h>
#include <glut.h>
#endif

#define DEG2RAD 0.0174532925
#define M_INFINITY 50.0f
#define LIGHTMAP_SIZE 16

extern bool wireframe;

typedef struct pnt3d {
  float x;
  float y;
  float z;
  pnt3d():x(0),y(0),z(0){};
  pnt3d(float in_x,float in_y,float in_z):x(in_x),y(in_y),z(in_z){}
} pnt3d;

typedef struct surf {
  std::vector<pnt3d> verts;
  float n[3];
} surf;

typedef struct vec3d {
  float x;
  float y;
  float z;
  float px;
  float py;
  float pz;
  vec3d():x(0),y(0),z(0),px(0),py(0),pz(0){};
  vec3d(float in_x,float in_y,float in_z):x(in_x),y(in_y),z(in_z),px(0),py(0),pz(0){};
  vec3d(float in_x,float in_y,float in_z, float in_px,float in_py,float in_pz):x(in_x),y(in_y),z(in_z),px(in_px),py(in_py),pz(in_pz){};
  float mag(){return sqrt(x*x + y*y + z*z);}
} vec3d;

typedef struct rainType {
  float x;
  float y;
  float z;
  float l;
  int hit;
  rainType():x(0),y(0),z(0),l(1),hit(0){};
  rainType(float in_x,float in_y,float in_z):x(in_x),y(in_y),z(in_z),l(1),hit(0){};
  rainType(float in_x,float in_y,float in_z,float in_l):x(in_x),y(in_y),z(in_z),l(in_l),hit(0){};
} rainType;

class obj {
  public:
     float x;
     float y;
     float z;
     std::vector<surf> surface;
     //materialStruct material;
     obj():x(0),y(0),z(0),surface(){};
     obj(float in_x,float in_y,float in_z):x(in_x),y(in_y),z(in_z),surface(){}
     void drawObj(int index);
     void drawShadow(float lx, float ly, float lz);
     void makeShadow(surf s, float x, float y, float z);
     bool hitTest(float ix,float iy,float iz);
     float fx;//floor (what you stand on)
     float fy;
     float fz;
     float bx;//bounds
     float by;
     float bz;
     bool moving;//movement
     float mx;
     float mz;
  //private:
};

void shadowPlane();

float dot_product(float v1[3], float v2[3]);

void normalize(float v[3]);;

obj newSlope(float x,float y,float z,float x2,float y2,float z2,int dirx, int m);

obj newCube(float x,float y,float z,float dx,float dy,float dz);
